DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | List of all members
DcmFileFormat Class Reference

a class handling the DICOM file format (with meta header) More...

Inheritance diagram for DcmFileFormat:

## Public Member Functions
| DcmFileFormat ()
| default constructor
| DcmFileFormat (DcmDataset *dataset, OFBool deepCopy=OFTrue)
| constructor taking an existing dataset for initialization. More...
| DcmFileFormat (const DcmFileFormat &old)
| copy constructor More...
virtual | ~DcmFileFormat ()
| destructor
DcmFileFormat & | operator= (const DcmFileFormat &obj)
| assignment operator More...
virtual DcmObject * | clone () const
| clone method More...
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying. More...
virtual DcmEVR | ident () const
| get type identifier More...
virtual OFCondition | clear ()
| clear file meta information header and dataset More...
virtual void | removeInvalidGroups ()
| remove all elements with an invalid group number from the meta information header and dataset
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print meta header and dataset to a stream More...
virtual OFCondition | validateMetaInfo (const E_TransferSyntax oxfer, const E_FileWriteMode writeMode=EWM_createNewMeta)
| make sure that all data elements of the file meta information header are existent in metainfo and contain correct values. More...
DcmMetaInfo * | getMetaInfo ()
| get file meta information header part of the fileformat More...
DcmDataset * | getDataset ()
| get dataset part of the fileformat More...
DcmDataset * | getAndRemoveDataset ()
| get dataset part and remove it from the fileformat. More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer=EXS_Unknown)
| check if this DICOM object can be encoded in the given transfer syntax. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax xfer=EXS_Unknown, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| read object from a stream. More...
virtual OFCondition | readUntilTag (DcmInputStream &inStream, const E_TransferSyntax xfer=EXS_Unknown, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength, const DcmTagKey &stopParsingAtElement=DCM_UndefinedTagKey)
| read object from a stream, up to the attribute tag stopParsingAtElement. More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write fileformat to a stream More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache, const E_GrpLenEncoding glenc, const E_PaddingEncoding padenc=EPD_noChange, const Uint32 padlen=0, const Uint32 subPadlen=0, Uint32 instanceLength=0, const E_FileWriteMode writeMode=EWM_createNewMeta)
| write object to a stream (abstract) More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format. More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format. More...
virtual OFCondition | loadFile (const OFFilename &fileName, const E_TransferSyntax readXfer=EXS_Unknown, const E_GrpLenEncoding groupLength=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength, const E_FileReadMode readMode=ERM_autoDetect)
| load object from a DICOM file. More...
virtual OFCondition | loadFileUntilTag (const OFFilename &fileName, const E_TransferSyntax readXfer=EXS_Unknown, const E_GrpLenEncoding groupLength=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength, const E_FileReadMode readMode=ERM_autoDetect, const DcmTagKey &stopParsingAtElement=DCM_UndefinedTagKey)
| load object from a DICOM file, up to the attribute tag stopParsingAtElement. More...
virtual OFCondition | saveFile (const OFFilename &fileName, const E_TransferSyntax writeXfer=EXS_Unknown, const E_EncodingType encodingType=EET_UndefinedLength, const E_GrpLenEncoding groupLength=EGL_recalcGL, const E_PaddingEncoding padEncoding=EPD_noChange, const Uint32 padLength=0, const Uint32 subPadLength=0, const E_FileWriteMode writeMode=EWM_createNewMeta)
| save object to a DICOM file. More...
OFCondition | chooseRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam)
| select a specific representation (compressed or uncompressed) of the dataset and create the representation if needed. More...
OFBool | hasRepresentation (const E_TransferSyntax repType, const DcmRepresentationParameter *repParam)
| check if all PixelData elements in this dataset have a representation conforming to the given transfer syntax and representation parameters (see dcpixel.h for definition of "conforming"). More...
void | removeAllButOriginalRepresentations ()
| removes all but the original representation in all pixel data elements
void | removeAllButCurrentRepresentations ()
| removes all but the current representation in all pixel data elements. More...
E_FileReadMode | getReadMode () const
| get current file read mode. More...
void | setReadMode (const E_FileReadMode readMode)
| set current file read mode. More...
void | setImplementationClassUID (const OFString &implementationClassUID)
| set Implementation Class UID to be used when writing the file (unless the write mode EWM_dontUpdateMeta is used, in which case the metaheader is not updated.) More...
void | setImplementationVersionName (const OFString &implementationVersionName)
| set Implementation Version Name to be used when writing the file (unless the write mode EWM_dontUpdateMeta is used, in which case the metaheader is not updated.) More...
virtual OFCondition | insertItem (DcmItem *item, const unsigned long where=DCM_EndOfListIndex)
| method inherited from base class that shall not be used for instances of this class. More...
virtual DcmItem * | remove (const unsigned long num)
| method inherited from base class that shall not be used for instances of this class. More...
virtual DcmItem * | remove (DcmItem *item)
| method inherited from base class that shall not be used for instances of this class. More...
virtual OFCondition | convertCharacterSet (const OFString &fromCharset, const OFString &toCharset, const size_t flags=0)
| convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet from the given source character set to the given destination character set. More...
virtual OFCondition | convertCharacterSet (const OFString &toCharset, const size_t flags=0)
| convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet to the given destination character set. More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet from the currently selected source character set to the currently selected destination character set More...
virtual OFCondition | convertToUTF8 ()
| convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet to UTF-8 (Unicode). More...
Public Member Functions inherited from DcmSequenceOfItems
| DcmSequenceOfItems (const DcmTag &tag)
| constructor. More...
| DcmSequenceOfItems (const DcmSequenceOfItems &oldSeq)
| copy constructor More...
virtual | ~DcmSequenceOfItems ()
| destructor
DcmSequenceOfItems & | operator= (const DcmSequenceOfItems &obj)
| copy assignment operator More...
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type. More...
OFCondition | error () const
| returns current status flag
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree. More...
virtual OFCondition | checkValue (const OFString &card="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM More...
virtual unsigned long | getVM ()
| get value multiplicity More...
virtual unsigned long | getNumberOfValues ()
| get number of values (items) stored in this sequence. More...
virtual unsigned long | card () const
| get cardinality of this sequence More...
virtual OFCondition | computeGroupLengthAndPadding (const E_GrpLenEncoding glenc, const E_PaddingEncoding padenc=EPD_noChange, const E_TransferSyntax xfer=EXS_Unknown, const E_EncodingType enctype=EET_ExplicitLength, const Uint32 padlen=0, const Uint32 subPadlen=0, Uint32 instanceLength=0)
| This function takes care of group length and padding elements in the current element list according to what is specified in glenc and padenc. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual void | transferInit ()
| initialize the transfer state of this object. More...
virtual void | transferEnd ()
| finalize the transfer state of this object. More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| special write method for creation of digital signatures More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters at any nesting level. More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet at any nesting level. More...
virtual OFCondition | prepend (DcmItem *item)
| insert the given item at the start of the item list maintained by this sequence. More...
virtual OFCondition | insert (DcmItem *item, unsigned long where=DCM_EndOfListIndex, OFBool before=OFFalse)
| insert the given item at the given position within the item list maintained by this sequence. More...
virtual OFCondition | append (DcmItem *item)
| insert the given item at the end of the item list maintained by this sequence. More...
virtual OFCondition | insertAtCurrentPos (DcmItem *item, OFBool before=OFFalse)
| insert new item a current position. More...
virtual DcmItem * | getItem (const unsigned long num)
| access an item from the sequence. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes, that is, DcmItem and DcmSequenceOfItems. More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this sequence is empty More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored element value More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
virtual OFCondition | loadAllDataIntoMemory (void)
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value. More...
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmElement (const DcmElement &old)
| copy constructor More...
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory More...
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8. More...
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16. More...
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16. More...
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32. More...
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32. More...
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32. More...
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64. More...
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64. More...
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64. More...
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey. More...
virtual OFCondition | getOFString (OFString &str, const unsigned long pos, OFBool normalize=OFTrue)
| retrieve a single value of type string. More...
virtual OFCondition | getOFStringArray (OFString &value, OFBool normalize=OFTrue)
| get entire element value as a character string. More...
virtual OFCondition | getString (char *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getString (char *&val, Uint32 &len)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16. More...
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16. More...
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32. More...
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32. More...
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32. More...
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64. More...
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64. More...
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64. More...
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object). More...
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putString (const char *val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putString (const char *val, const Uint32 len)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value. More...
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value. More...
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value. More...
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value. More...
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value. More...
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value. More...
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value. More...
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value. More...
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value. More...
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued). More...
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued). More...
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued). More...
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued). More...
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued). More...
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued). More...
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued). More...
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it. More...
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it. More...
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file. More...
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again. More...
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image. More...
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object. More...
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image More...
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching. More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching. More...
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise. More...
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored. More...
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Private Member Functions
OFCondition | checkMetaHeaderValue (DcmMetaInfo *metainfo, DcmDataset *dataset, const DcmTagKey &atagkey, DcmObject *obj, const E_TransferSyntax oxfer, const E_FileWriteMode writeMode) const
| This function checks if a particular data element of the file meta information header is existent. More...

## Static Private Member Functions
static E_TransferSyntax | lookForXfer (DcmMetaInfo *metainfo)
| read DCM_TransferSyntaxUID from meta header dataset and return as E_TransferSyntax value More...

## Private Attributes
E_FileReadMode | FileReadMode
| file read mode, specifies whether to read the meta header or not
OFString | ImplementationClassUID
| implementation class UID to write in the meta-header
OFString | ImplementationVersionName
| implementation version name to write in the meta-header

## Additional Inherited Members
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR) More...
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR) More...
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM) More...
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string. More...
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM) More...
Protected Member Functions inherited from DcmSequenceOfItems
| DcmSequenceOfItems (const DcmTag &tag, const Uint32 len, OFBool readAsUN=OFFalse)
| constructor. More...
virtual OFCondition | readTagAndLength (DcmInputStream &inStream, const E_TransferSyntax xfer, DcmTag &tag, Uint32 &length)
| This function reads tag and length information from inStream and returns this information to the caller. More...
virtual OFCondition | makeSubObject (DcmObject *&subObject, const DcmTag &newTag, const Uint32 newLength)
| helper function for read(). More...
OFCondition | readSubItem (DcmInputStream &inStream, const DcmTag &newTag, const Uint32 newLength, const E_TransferSyntax xfer, const E_GrpLenEncoding glenc, const Uint32 maxReadLength=DCM_MaxReadLength)
| helper function for read(). More...
virtual OFCondition | searchSubFromHere (const DcmTagKey &tag, DcmStack &resultStack, const OFBool searchIntoSub)
| helper function for search(). More...
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value. More...
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value. More...
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block More...
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size. More...
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this. More...
virtual void | postLoadValue ()
| performs clean-up functions after loading an attribute value into main memory. More...
virtual Uint8 * | newValueField ()
| This function creates a byte array of Length bytes and returns this array. More...
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back More...
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format More...
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format More...
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format More...
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format More...
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field More...
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field More...
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...
Protected Attributes inherited from DcmSequenceOfItems
DcmList * | itemList
| the list of items maintained by this sequence object
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class handling the DICOM file format (with meta header)

## Constructor & Destructor Documentation

## ◆ DcmFileFormat() [1/2]

DcmFileFormat::DcmFileFormat | ( | DcmDataset * | dataset,
|  | OFBool | deepCopy = `OFTrue`
| ) |  |

constructor taking an existing dataset for initialization.

Depending on the parameters, a deep or shallow copy is performed.

Parameters

  dataset | the dataset to be inserted into the new DcmFileFormat object. If NULL, an empty dataset is created and inserted instead.
  deepCopy | If OFTrue (default), a deep copy of the dataset is performed. Otherwise only the pointer is copied and the ownership of the dataset is taken over by the DcmFileFormat object.

## ◆ DcmFileFormat() [2/2]

DcmFileFormat::DcmFileFormat | ( | const DcmFileFormat & | old | ) |

copy constructor

Parameters

  old | element to be copied

## Member Function Documentation

## ◆ calcElementLength()

virtual Uint32 DcmFileFormat::calcElementLength | ( | const E_TransferSyntax | xfer,
|  | const E_EncodingType | enctype
| ) |  |
| virtual

calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

For elements, the length includes the length of the tag, length field, VR field and the value itself, for items and sequences it returns the length of the complete item or sequence including delimitation tags if applicable.

Warning
  Since calcElementLength() returns a 32 bit integer, an overflow during calculation is possible for some derived classes that actually represent a compound value (e.g. items like DcmPixelItem). Such overflows will be detected, in which case the maximum possible value will be returned instead, coinciding with DCM_UndefinedLength.
  The implementation in DcmPixelData may return zero if no conforming representation exists and set the EC_RepresentationNotFound error flag to indicated it.
  When calculation the length of a sequence or an item containing multiple attributes, the implementation may return DCM_UndefinedLength to indicate a value that can not be encoded as a 32 bit length field. It will even do so if "dcmWriteOversizedSeqsAndItemsUndefined" is disabled, but then also set the EC_SeqOrItemContentOverflow error flag (inside getLength()) to indicated it.

Note
  Just check for zero or DCM_UndefinedLength return value and then have a look at the error flag in either case.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  length of DICOM element

Reimplemented from DcmSequenceOfItems.

## ◆ canWriteXfer()

virtual OFBool DcmFileFormat::canWriteXfer | ( | const E_TransferSyntax | newXfer,
|  | const E_TransferSyntax | oldXfer = `EXS_Unknown`
| ) |  |
| virtual

check if this DICOM object can be encoded in the given transfer syntax.

Parameters

  newXfer | transfer syntax in which the DICOM object is to be encoded
  oldXfer | transfer syntax in which the DICOM object was read or created.

Returns
  true if object can be encoded in desired transfer syntax, false otherwise.

Reimplemented from DcmSequenceOfItems.

## ◆ checkMetaHeaderValue()

OFCondition DcmFileFormat::checkMetaHeaderValue | ( | DcmMetaInfo * | metainfo,
|  | DcmDataset * | dataset,
|  | const DcmTagKey & | atagkey,
|  | DcmObject * | obj,
|  | const E_TransferSyntax | oxfer,
|  | const E_FileWriteMode | writeMode
| ) |  | const
| private

This function checks if a particular data element of the file meta information header is existent.

If the element is not existent, it will be inserted. Additionally, this function makes sure that the corresponding data element will contain a correct value.

Parameters

  metainfo | the meta header information
  dataset | the data set information
  atagkey | tag of the data element which shall be checked
  obj | data object from metainfo which represents the data element that shall be checked. Equals NULL if this data element is not existent in the meta header information.
  oxfer | The transfer syntax which shall be used.
  writeMode | flag indicating whether to update the file meta information or not

Returns
  EC_Normal if successful, an error code otherwise

## ◆ chooseRepresentation()

OFCondition DcmFileFormat::chooseRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam
| ) |  |
| inline

select a specific representation (compressed or uncompressed) of the dataset and create the representation if needed.

This may cause compression or decompression to be applied to the pixel data in the dataset.

Parameters

  repType | desired transfer syntax
  repParam | desired representation parameter (e.g. quality factor for lossy compression)

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ clear()

virtual OFCondition DcmFileFormat::clear | ( |  | ) |
| virtual

clear file meta information header and dataset

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ clone()

virtual DcmObject* DcmFileFormat::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmSequenceOfItems.

## ◆ convertCharacterSet() [1/3]

virtual OFCondition DcmFileFormat::convertCharacterSet | ( | const OFString & | fromCharset,
|  | const OFString & | toCharset,
|  | const size_t | flags = `0`
| ) |  |
| virtual

convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet from the given source character set to the given destination character set.

The defined terms for a particular character set can be found in the DICOM standard, e.g. "ISO_IR 100" for ISO 8859-1 (Latin 1) or "ISO_IR 192" for Unicode in UTF-8. An empty string denotes the default character repertoire, which is ASCII (7-bit). If multiple values are given for 'fromCharset' (separated by a backslash) code extension techniques are used and escape sequences may be encountered in the source string to switch between the specified character sets.

Parameters

  fromCharset | name of the source character set(s) used for the conversion
  toCharset | name of the destination character set used for the conversion. Only a single value is permitted (i.e. no code extensions).
  flags | optional flag used to customize the conversion (see DCMTypes::CF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ convertCharacterSet() [2/3]

virtual OFCondition DcmFileFormat::convertCharacterSet | ( | const OFString & | toCharset,
|  | const size_t | flags = `0`
| ) |  |
| virtual

convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet to the given destination character set.

The source character set is determined automatically from the value of the SpecificCharacterSet (0008,0005) element. The defined terms for the destination character set can be found in the DICOM standard, e.g. "ISO_IR 100" for ISO 8859-1 (Latin 1) or "ISO_IR 192" for Unicode in UTF-8. An empty string denotes the default character repertoire, which is ASCII (7-bit). NB: In case of a DICOMDIR, the SpecificCharacterSet in the main dataset is neither checked nor updated, since the Basic Directory IOD has no SOP Common Module.

Parameters

  toCharset | name of the destination character set used for the conversion. Only a single value is permitted (i.e. no code extensions).
  flags | optional flag used to customize the conversion (see DCMTypes::CF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ convertCharacterSet() [3/3]

virtual OFCondition DcmFileFormat::convertCharacterSet | ( | DcmSpecificCharacterSet & | converter | ) |
| virtual

convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet from the currently selected source character set to the currently selected destination character set

Parameters

  converter | character set converter to be used to convert the element values

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ convertToUTF8()

virtual OFCondition DcmFileFormat::convertToUTF8 | ( |  | ) |
| virtual

convert all element values that are contained in the dataset and that are affected by SpecificCharacterSet to UTF-8 (Unicode).

The value of the SpecificCharacterSet (0008,0005) element is updated, set or deleted automatically if needed. The transliteration mode is disabled, i.e. the conversion flags are explicitly set to 0 - see convertCharacterSet(). NB: In case of a DICOMDIR, the SpecificCharacterSet in the main dataset is neither checked nor updated, since the Basic Directory IOD has no SOP Common Module.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ copyFrom()

virtual OFCondition DcmFileFormat::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ getAndRemoveDataset()

DcmDataset* DcmFileFormat::getAndRemoveDataset | ( |  | ) |

get dataset part and remove it from the fileformat.

Please note that a new, initially empty dataset is also added to the fileformat.

Returns
  reference to previously stored but now removed dataset

## ◆ getDataset()

DcmDataset* DcmFileFormat::getDataset | ( |  | ) |

get dataset part of the fileformat

Returns
  reference to internally stored dataset

## ◆ getMetaInfo()

DcmMetaInfo* DcmFileFormat::getMetaInfo | ( |  | ) |

get file meta information header part of the fileformat

Returns
  reference to internally stored file meta information header

## ◆ getReadMode()

E_FileReadMode DcmFileFormat::getReadMode | ( |  | ) | const
| inline

get current file read mode.

This mode specifies whether a file is read as a fileformat or dataset (without meta header). In addition, the reading can be restricted to DICOM files only.

Returns
  file read mode

## ◆ hasRepresentation()

OFBool DcmFileFormat::hasRepresentation | ( | const E_TransferSyntax | repType,
|  | const DcmRepresentationParameter * | repParam
| ) |  |
| inline

check if all PixelData elements in this dataset have a representation conforming to the given transfer syntax and representation parameters (see dcpixel.h for definition of "conforming").

Parameters

  repType | desired transfer syntax
  repParam | desired representation parameter (e.g. quality factor for lossy compression)

Returns
  true if all pixel elements have the desired representation, false otherwise

## ◆ ident()

virtual DcmEVR DcmFileFormat::ident | ( |  | ) | const
| virtual

get type identifier

Returns
  type identifier of this class (EVR_fileFormat)

Reimplemented from DcmSequenceOfItems.

## ◆ insertItem()

virtual OFCondition DcmFileFormat::insertItem | ( | DcmItem * | item,
|  | const unsigned long | where = `DCM_EndOfListIndex`
| ) |  |
| virtual

method inherited from base class that shall not be used for instances of this class.

Method immediately returns with error code.

Parameters

  item | item
  where | where

Returns
  always returns EC_IllegalCall.

## ◆ loadFile()

virtual OFCondition DcmFileFormat::loadFile | ( | const OFFilename & | fileName,
|  | const E_TransferSyntax | readXfer = `EXS_Unknown`,
|  | const E_GrpLenEncoding | groupLength = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`,
|  | const E_FileReadMode | readMode = `ERM_autoDetect`
| ) |  |
| virtual

load object from a DICOM file.

This method supports DICOM objects stored as a file (with meta header) or as a dataset (without meta header). By default, the presence of a meta header is detected automatically.

Parameters

  fileName | name of the file to load (may contain wide chars if support enabled). Since there are various constructors for the OFFilename class, a "char *", "OFString" or "wchar_t *" can also be passed directly to this parameter.
  readXfer | transfer syntax used to read the data (auto detection if EXS_Unknown)
  groupLength | flag, specifying how to handle the group length tags
  maxReadLength | maximum number of bytes to be read for an element value. Element values with a larger size are not loaded until their value is retrieved (with getXXX()) or loadAllDataIntoMemory() is called.
  readMode | read file with or without meta header, i.e. as a fileformat or a dataset. Use ERM_fileOnly in order to force the presence of a meta header.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ loadFileUntilTag()

virtual OFCondition DcmFileFormat::loadFileUntilTag | ( | const OFFilename & | fileName,
|  | const E_TransferSyntax | readXfer = `EXS_Unknown`,
|  | const E_GrpLenEncoding | groupLength = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`,
|  | const E_FileReadMode | readMode = `ERM_autoDetect`,
|  | const DcmTagKey & | stopParsingAtElement = `DCM_UndefinedTagKey`
| ) |  |
| virtual

load object from a DICOM file, up to the attribute tag stopParsingAtElement.

This method supports DICOM objects stored as a file (with meta header) or as a dataset (without meta header). By default, the presence of a meta header is detected automatically.

Parameters

  fileName | name of the file to load (may contain wide chars if support enabled). Since there are various constructors for the OFFilename class, a "char *", "OFString" or "wchar_t *" can also be passed directly to this parameter.
  readXfer | transfer syntax used to read the data (auto detection if EXS_Unknown)
  groupLength | flag, specifying how to handle the group length tags
  maxReadLength | maximum number of bytes to be read for an element value. Element values with a larger size are not loaded until their value is retrieved (with getXXX()) or loadAllDataIntoMemory() is called.
  readMode | read file with or without meta header, i.e. as a fileformat or a dataset. Use ERM_fileOnly in order to force the presence of a meta header.
  stopParsingAtElement | parsing of the input stream is stopped when this tag key or any higher tag is encountered.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ lookForXfer()

static E_TransferSyntax DcmFileFormat::lookForXfer | ( | DcmMetaInfo * | metainfo | ) |
| static private

read DCM_TransferSyntaxUID from meta header dataset and return as E_TransferSyntax value

Parameters

  metainfo | meta-header dataset

Returns
  E_TransferSyntax value for DCM_TransferSyntaxUID, EXS_Unknown if not found or unknown

## ◆ operator=()

DcmFileFormat& DcmFileFormat::operator= | ( | const DcmFileFormat & | obj | ) |

assignment operator

Parameters

  obj | fileformat to be assigned/copied

Returns
  reference to this object

## ◆ print()

virtual void DcmFileFormat::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`,
|  | const int | level = `0`,
|  | const char * | pixelFileName = `NULL`,
|  | size_t * | pixelCounter = `NULL`
| ) |  |
| virtual

print meta header and dataset to a stream

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | optional filename used to write the raw pixel data file
  pixelCounter | optional counter used for automatic pixel data filename creation

Reimplemented from DcmSequenceOfItems.

## ◆ read()

virtual OFCondition DcmFileFormat::read | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer = `EXS_Unknown`,
|  | const E_GrpLenEncoding | glenc = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`
| ) |  |
| virtual

read object from a stream.

Parameters

  inStream | DICOM input stream
  xfer | transfer syntax to use when parsing
  glenc | handling of group length parameters
  maxReadLength | attribute values larger than this value are skipped while parsing and read later upon first access if the stream type supports this.

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ readUntilTag()

virtual OFCondition DcmFileFormat::readUntilTag | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | xfer = `EXS_Unknown`,
|  | const E_GrpLenEncoding | glenc = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`,
|  | const DcmTagKey & | stopParsingAtElement = `DCM_UndefinedTagKey`
| ) |  |
| virtual

read object from a stream, up to the attribute tag stopParsingAtElement.

Parameters

  inStream | DICOM input stream
  xfer | transfer syntax to use when parsing
  glenc | handling of group length parameters
  maxReadLength | attribute values larger than this value are skipped while parsing and read later upon first access if the stream type supports this.
  stopParsingAtElement | parsing of the input stream is stopped when this tag key or any higher tag is encountered.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ remove() [1/2]

virtual DcmItem* DcmFileFormat::remove | ( | const unsigned long | num | ) |
| virtual

method inherited from base class that shall not be used for instances of this class.

Method immediately returns.

Parameters

  num | num

Returns
  always returns NULL.

Reimplemented from DcmSequenceOfItems.

## ◆ remove() [2/2]

virtual DcmItem* DcmFileFormat::remove | ( | DcmItem * | item | ) |
| virtual

method inherited from base class that shall not be used for instances of this class.

Method immediately returns.

Parameters

  item | item

Returns
  always returns NULL.

Reimplemented from DcmSequenceOfItems.

## ◆ removeAllButCurrentRepresentations()

void DcmFileFormat::removeAllButCurrentRepresentations | ( |  | ) |
| inline

removes all but the current representation in all pixel data elements.

Makes the current representation original.

## ◆ saveFile()

virtual OFCondition DcmFileFormat::saveFile | ( | const OFFilename & | fileName,
|  | const E_TransferSyntax | writeXfer = `EXS_Unknown`,
|  | const E_EncodingType | encodingType = `EET_UndefinedLength`,
|  | const E_GrpLenEncoding | groupLength = `EGL_recalcGL`,
|  | const E_PaddingEncoding | padEncoding = `EPD_noChange`,
|  | const Uint32 | padLength = `0`,
|  | const Uint32 | subPadLength = `0`,
|  | const E_FileWriteMode | writeMode = `EWM_createNewMeta`
| ) |  |
| virtual

save object to a DICOM file.

Parameters

  fileName | name of the file to save (may contain wide chars if support enabled). Since there are various constructors for the OFFilename class, a "char *", "OFString" or "wchar_t *" can also be passed directly to this parameter.
  writeXfer | transfer syntax used to write the data (EXS_Unknown means use original)
  encodingType | flag, specifying the encoding with undefined or explicit length
  groupLength | flag, specifying how to handle the group length tags
  padEncoding | flag, specifying how to handle the padding tags
  padLength | number of bytes used for the dataset padding (has to be an even number)
  subPadLength | number of bytes used for the item padding (has to be an even number)
  writeMode | write file with or without meta header. Also allows for updating the information in the file meta information header. The default behavior is to delete all old meta information in order to create it from scratch.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setImplementationClassUID()

void DcmFileFormat::setImplementationClassUID | ( | const OFString & | implementationClassUID | ) |

set Implementation Class UID to be used when writing the file (unless the write mode EWM_dontUpdateMeta is used, in which case the metaheader is not updated.)

Parameters

  implementationClassUID | implementation class UID

## ◆ setImplementationVersionName()

void DcmFileFormat::setImplementationVersionName | ( | const OFString & | implementationVersionName | ) |

set Implementation Version Name to be used when writing the file (unless the write mode EWM_dontUpdateMeta is used, in which case the metaheader is not updated.)

Parameters

  implementationVersionName | implementation version name

## ◆ setReadMode()

void DcmFileFormat::setReadMode | ( | const E_FileReadMode | readMode | ) |
| inline

set current file read mode.

This mode specifies whether a file is read as a fileformat or dataset (without meta header). In addition, the reading can be restricted to DICOM files only.

Parameters

  readMode | file read mode to be set

## ◆ validateMetaInfo()

virtual OFCondition DcmFileFormat::validateMetaInfo | ( | const E_TransferSyntax | oxfer,
|  | const E_FileWriteMode | writeMode = `EWM_createNewMeta`
| ) |  |
| virtual

make sure that all data elements of the file meta information header are existent in metainfo and contain correct values.

Parameters

  oxfer | the transfer syntax which shall be used
  writeMode | flag indicating whether to update the file meta information or not. The default behavior is to delete all old meta information in order to create it from scratch.

Returns
  EC_Normal if valid, an error code otherwise

## ◆ write() [1/2]

virtual OFCondition DcmFileFormat::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| virtual

write fileformat to a stream

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ write() [2/2]

virtual OFCondition DcmFileFormat::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache,
|  | const E_GrpLenEncoding | glenc,
|  | const E_PaddingEncoding | padenc = `EPD_noChange`,
|  | const Uint32 | padlen = `0`,
|  | const Uint32 | subPadlen = `0`,
|  | Uint32 | instanceLength = `0`,
|  | const E_FileWriteMode | writeMode = `EWM_createNewMeta`
| ) |  |
| virtual

write object to a stream (abstract)

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax (EXS_Unknown means use original)
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL
  glenc | group length encoding
  padenc | dataset trailing padding encoding
  padlen | padding structure size for complete file
  subPadlen | padding structure set for sequence items
  instanceLength | number of extra bytes added to the item/dataset length used when computing the padding. This parameter is for instance used to pass the length of the file meta information header from the DcmFileFormat to the DcmDataset object.
  writeMode | write file with or without meta header. Also allows for updating the information in the file meta information header. The default behavior is to delete all old meta information in order to create it from scratch.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ writeJson()

virtual OFCondition DcmFileFormat::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format
| ) |  |
| virtual

write object in JSON format.

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

## ◆ writeXML()

virtual OFCondition DcmFileFormat::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`
| ) |  |
| virtual

write object in XML format.

The XML declaration (e.g. <?xml version="1.0"?>) is not written by this function.

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmSequenceOfItems.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcfilefo.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1